/*
 * css-init.c
 *
 * Copyright 1999 Derek Fawcus.
 *
 * Released under version 2 of the GPL.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include "css-descramble.h"

static struct playkey pkey1a1 = {0x36b, {0x51,0x67,0x67,0xc5,0xe0}};
static struct playkey pkey2a1 = {0x762, {0x2c,0xb2,0xc1,0x09,0xee}};
static struct playkey pkey1b1 = {0x36b, {0x90,0xc1,0xd7,0x84,0x48}};

static struct playkey pkey1a2 = {0x2f3, {0x51,0x67,0x67,0xc5,0xe0}};
static struct playkey pkey2a2 = {0x730, {0x2c,0xb2,0xc1,0x09,0xee}};
static struct playkey pkey1b2 = {0x2f3, {0x90,0xc1,0xd7,0x84,0x48}};

static struct playkey pkey1a3 = {0x235, {0x51,0x67,0x67,0xc5,0xe0}};
static struct playkey pkey1b3 = {0x235, {0x90,0xc1,0xd7,0x84,0x48}};

static struct playkey pkey3a1 = {0x249, {0xb7,0x3f,0xd4,0xaa,0x14}}; /* DVD specific ? */
static struct playkey pkey4a1 = {0x028, {0x53,0xd4,0xf7,0xd9,0x8f}}; /* DVD specific ? */


static struct playkey *playkeys[] = {
	&pkey1a1, &pkey2a1, &pkey1b1,
	&pkey1a2, &pkey2a2, &pkey1b2,
	&pkey1a3, &pkey1b3,
	&pkey3a1, &pkey4a1,
	NULL};

static unsigned char disk_key[2048];

unsigned long sectors = 0;
unsigned long crypted = 0;
unsigned long skipped = 0;

int do_all = 0;
int do_video = 0;
int do_ac3 = 0;
int do_mpg = 0;
int verbose = 0;
int keep_pack = 0;
int keep_pes = -1;

#define STCODE(p,a,b,c,d) ((p)[0] == a && (p)[1] == b && (p)[2] == c && (p)[3] == d)

int css_init(char *title_key, char *diskKey, char *titlef)
{
	int fd;

	fprintf (stderr, "opening %s\n", diskKey);
	if ((fd = open(diskKey, O_RDONLY)) == -1) {
		perror("can't open disk-key");
		return 1;
	}
	if (read(fd, disk_key, 2048) != 2048) {
		perror("can't read disk-key");
		close(fd);
		return 1;
	}
	close(fd);

	fprintf (stderr, "opening %s\n", titlef);
	if ((fd = open(titlef, O_RDONLY)) == -1) {
		perror("can't open title-key");
		return 1;
	}
	if (read(fd, title_key, 5) != 5) {
		perror("can't read title-key");
		close(fd);
		return 1;
	}
	close(fd);

	if (!css_decrypttitlekey(title_key, disk_key, playkeys)) {
		return 3;
	}

	return 0;
}


