#include "ac3dec/ac3.h"

#define SUBTITLE_BUFFER_SIZE        (1024*64)

// ac3stat
#define AC3_STOP         0
#define AC3_PLAY         1
#define AC3_START        2


// subtitleStat
#define SUBTITLE_DISPLAY         0
#define SUBTITLE_OVERLAY         1
#define SUBTITLE_HIDE            2

// video, css 
#define V_OFF                   -1
#define V_PLAY                   0
#define V_FREEZE                 1
#define V_SLOW                   2
#define V_FAST                   3

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* union semun is defined by including <sys/sem.h> */
#else
/* according to X/OPEN we have to define it ourselves */
union semun {
  int val;                    /* value for SETVAL */
  struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
  unsigned short int *array;  /* array for GETALL, SETALL */
  struct seminfo *__buf;      /* buffer for IPC_INFO */
};
#endif

extern int semId;

struct ir_command
{
  char state;
  char command[32];
  int  number;
};

struct data_buf
{
  int exit_child;
  unsigned int input_pointer;
  unsigned int output_pointer;
  int lpcm_stat;
  unsigned char data[SUBTITLE_BUFFER_SIZE];
  unsigned int input_pointer_ac3;
  unsigned int output_pointer_ac3;
  char ac3_data[AC3_BUFFER_SIZE];
  unsigned char lpcm_data[3*2048];

  //  int video;            // 1 playback video
  int video_mode;       // VIDEO_MODE_PAL, VIDEO_MODE_NTSC
  int css;              // 1 css decode,
  int ac3;             // -1 no ac3 sound, -2 if only 1 soundtrack, 0-7 play soundtrack x
  int ac3stat;         // AC3_PLAY, AC3_STOP, AC3_START
  int lpcm;             // -1 no lpcm sound, -2 if only 1 soundtrack, 0-7 play soundtrack x
  int mpeg_audio;       // -1 no mpeg sound, 0 play mpeg sound
  int skip;             // skip MB of input file
  int subtitles;       // 0-31 subtitles x
  int subtitleStat;    // SUBTITLE_DISPLAY, SUBTITLE_OVERLAY, SUBTITLE_HIDE
  int remote;           // 1 use LIRC
  int inputFile;
  int changeFile;
  int go_to;
  int port;
  struct ir_command ir;
  char fileName[256];
  char directory[256];
  char ac3player[128];
};

// data_buf changeFile
#define NEXT_FILE       1
#define PREW_FILE      -1
#define NEW_FILE        256
#define CURRENT_FILE    0

extern struct data_buf *data_buffer;

int sem_ctl(int semid, int semnum, int val);
int sem_op(int semid, int semnum, int op);
