#!/usr/bin/wish

set sock_fd -1;

proc send_command {command} {
    global sock_fd
    puts $sock_fd $command
    flush $sock_fd
}

proc exit1 {} {
    global sock_fd
    puts $sock_fd quit
    flush $sock_fd
    eval exec "sleep 1"
    close $sock_fd
    exit
}

if {$argc != 2} then {
    puts "\nusage:\tdvdplayer.tcl host_name port_number\n"
    exit
} 

set host [lindex $argv 0]
set port [lindex $argv 1]

puts "connecting to host: $host port: $port"

set sock_fd [socket $host $port]
puts $sock_fd "dvdplayer.tcl\n"

frame .rc -borderwidth 2
wm title . "DVDPLAYER"
pack .rc
frame .rc.rc1 -borderwidth 6
pack .rc.rc1 -side left
frame .rc.rc2 -borderwidth 6
pack .rc.rc2 -side right

frame .rc.rc1.a -borderwidth 1
frame .rc.rc1.b -borderwidth 1
frame .rc.rc1.c -borderwidth 1
frame .rc.rc1.d -borderwidth 1
pack  .rc.rc1.a -side top
pack  .rc.rc1.b -side top
pack  .rc.rc1.c -side top
pack  .rc.rc1.d -side top

button .rc.rc1.d.b0 -text "0"  -command "send_command 0"
button .rc.rc1.a.b1 -text "1"  -command "send_command 1"
button .rc.rc1.a.b2 -text "2"  -command "send_command 2"
button .rc.rc1.a.b3 -text "3"  -command "send_command 3"
button .rc.rc1.b.b4 -text "4"  -command "send_command 4"
button .rc.rc1.b.b5 -text "5"  -command "send_command 5"
button .rc.rc1.b.b6 -text "6"  -command "send_command 6"
button .rc.rc1.c.b7 -text "7"  -command "send_command 7"
button .rc.rc1.c.b8 -text "8"  -command "send_command 8"
button .rc.rc1.c.b9 -text "9"  -command "send_command 9"

pack .rc.rc1.d.b0 -side left
pack .rc.rc1.a.b1 -side left
pack .rc.rc1.a.b2 -side left
pack .rc.rc1.a.b3 -side left
pack .rc.rc1.b.b4 -side left
pack .rc.rc1.b.b5 -side left
pack .rc.rc1.b.b6 -side left
pack .rc.rc1.c.b7 -side left
pack .rc.rc1.c.b8 -side left
pack .rc.rc1.c.b9 -side left

frame .rc.rc2.a -borderwidth 1
frame .rc.rc2.b -borderwidth 1
frame .rc.rc2.c -borderwidth 1
frame .rc.rc2.d -borderwidth 2
pack  .rc.rc2.a -side top
pack  .rc.rc2.b -side top
pack  .rc.rc2.c -side top
pack  .rc.rc2.d -side bottom

button .rc.rc2.a.b0 -text "^"  -command "send_command Up"
button .rc.rc2.b.b1 -text "<"  -command "send_command Left"
button .rc.rc2.b.b2 -text "M"  -command "send_command Menu"
button .rc.rc2.b.b3 -text ">"  -command "send_command Right"
button .rc.rc2.c.b4 -text "v"  -command "send_command Down"
button .rc.rc2.d.b5 -text "Back" -command "send_command Vack"
button .rc.rc2.d.b6 -text "OK"  -command "send_command Ok"

pack .rc.rc2.a.b0 -side left
pack .rc.rc2.b.b1 -side left
pack .rc.rc2.b.b2 -side left
pack .rc.rc2.b.b3 -side left
pack .rc.rc2.c.b4 -side left
pack .rc.rc2.d.b5 -side left
pack .rc.rc2.d.b6 -side right

frame .rcb -borderwidth 4
pack .rcb

button .rcb.b0 -text "Pause" -command "send_command Back"
button .rcb.b1 -text "Slow"  -command "send_command Down"
button .rcb.b2 -text "Play"  -command "send_command Ok"
button .rcb.b3 -text "FF"    -command "send_command Up"

pack .rcb.b0 -side left
pack .rcb.b1 -side left
pack .rcb.b2 -side left
pack .rcb.b3 -side left

frame .rca -borderwidth 4
pack .rca -side top
button .rca.b1 -text "quit"  -command "exit1"
pack .rca.b1 -side right
